﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using PcmCore.Metier;
using PcmCore.Event;
using PcmCore.Donnees;

namespace Pcm.Gui
{
    public partial class AddContactWindow : Form
    {
        public event EventHandler<ContactAddedEventArgs> contactAjoute;

        private User utilisateur;

        public AddContactWindow (User utilisateur)
        {
            InitializeComponent ();
            this.utilisateur = utilisateur;
        }

        private void WAddContact_Load (object sender, EventArgs e)
        {

        }

        protected virtual void OnContactAdded(ContactAddedEventArgs arg)
        {
            contactAjoute (this, arg);
        }

        private void btValider_Click (object sender, EventArgs e)
        {
            if (txtNom.Text.Length < 3 && txtPrenom.Text.Length < 3)
            {
                MessageBox.Show ("Le nom et le prénom doivent être composés d'au moins 3 caractères", "Erreur de saisie", MessageBoxButtons.OK, MessageBoxIcon.Warning);
            }
            else
            {
                Contact saisieContact = new Contact (
                    txtNom.Text, txtPrenom.Text,
                    string.Format ("{0}/{1}/{2}", dpDateNaissance.Value.Day.ToString (), dpDateNaissance.Value.Month.ToString (), dpDateNaissance.Value.Year.ToString ()),
                    txtAdresse.Text, txtCodePostal.Text, txtVille.Text, txtTfixe.Text, txtTPort.Text, txtMail.Text);
                ContactsManager contactManager = new ContactsManager (saisieContact, utilisateur);
                if (contactManager.AjouterDonnees ())
                {
                    OnContactAdded (new ContactAddedEventArgs (saisieContact));
                }
                else
                {
                    MessageBox.Show ("Le contact n'a pas pu être ajouté", "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
                this.Close ();
            }
        }

        private void btAnnuler_Click (object sender, EventArgs e)
        {
            this.Close ();
        }
    }
}
