﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using PcmCore.Metier;
using PcmCore.Donnees;
using PcmCore.Event;

namespace Pcm.Gui
{
    public partial class AddUserWindow : Form
    {
        public event EventHandler<UserAddedEventArgs> utilisateurAjoute;

        public AddUserWindow ()
        {
            InitializeComponent ();
        }

        private void WUtilisateur_Load (object sender, EventArgs e)
        {

        }

        private void btAnnuler_Click (object sender, EventArgs e)
        {
            this.Close ();
        }

        /// <summary>
        /// Traitement effectué lors d'un clique sur le bouton valider
        /// Création d'un utilisateur dans la base de données
        /// La/Les vues sont notifiées quand un contact est ajouté
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btValider_Click (object sender, EventArgs e)
        {
            if (txtNomUtil.Text.Length < 4) MessageBox.Show("Votre nom d'utilisateur doit contenir au moins 4 caractères", "Erreur de saisie", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            else if (txtPasswd1.Text.Length < 6) MessageBox.Show ("Votre mot de passe doit contenir au moins 6 caractères", "Erreur de saisie", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            else if (!(txtPasswd1.Text == txtPasswd2.Text)) MessageBox.Show ("Les deux mot de passe ne sont pas identiques", "Erreur de saisie", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            else
            {
                User nouvelUtilisateur = new User (txtNomUtil.Text, txtPasswd1.Text);
                UserManager uManager = new UserManager (nouvelUtilisateur);

                if (!uManager.AjouterDonnees ())
                {
                    DialogResult result = MessageBox.Show ("L'utilisateur n'a pas put être ajouté", "Erreur", MessageBoxButtons.RetryCancel, MessageBoxIcon.Error);
                    if (result == DialogResult.Cancel)
                        this.Close ();
                }
                else
                {
                    lancerEventUtilisateurAjoute (new UserAddedEventArgs (nouvelUtilisateur.NomUtilisateur));
                    this.Close ();
                }
            }
        }

        private void lancerEventUtilisateurAjoute(UserAddedEventArgs e)
        {
            utilisateurAjoute (this, e);
        }
    }
}