﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using PcmCore.Metier;
using PcmCore.Donnees;
using PcmCore.Event;

namespace Pcm.Gui
{
    public partial class UserConnectionWindow : Form
    {
        public event EventHandler<UserConnectedEventArgs> utilisateurConnecte;

        public UserConnectionWindow ()
        {
            InitializeComponent ();
        }

        private void btAnnuler_Click (object sender, EventArgs e)
        {
            this.Close ();
        }

        private void btValider_Click (object sender, EventArgs e)
        {
            if (txtUser.Text.Length >= 4 && txtPasswd.Text.Length >= 6)
            {
                User utilisateurSaisie = new User (txtUser.Text, txtPasswd.Text);
                UserManager verficationUSaisie = new UserManager (utilisateurSaisie);
                utilisateurSaisie.IdUtilisateur = verficationUSaisie.VerifierDonnees ();

                if (utilisateurSaisie.IdUtilisateur > 0)
                {
                    // Envoi de l'utilisateur à la vue pour mise à jour
                    OnUtilisateurConnecte (new UserConnectedEventArgs (utilisateurSaisie));
                    MessageBox.Show ("Connexion OK");
                    this.Close ();
                }
                else
                {
                    DialogResult choixUtilisateur = MessageBox.Show ("L'utilisateur n'existe pas ou les identifiants sont incorrects", "Erreur d'identification", MessageBoxButtons.RetryCancel, MessageBoxIcon.Exclamation);
                    if (choixUtilisateur == DialogResult.Cancel)
                        this.Close ();
                }

                this.Close ();
            }
            else
            {
                MessageBox.Show ("Le nom d'utilisateur doit comporter au moins 4 caractères et le mot de passe 6 caractères", "Attention", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
        }

        // Emission de l'utilisateur
        protected virtual void OnUtilisateurConnecte (UserConnectedEventArgs utilisateur)
        {
            utilisateurConnecte (this, utilisateur);
        }

        private void WConnexion_Load (object sender, EventArgs e)
        {

        }
    }
}