﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using PcmCore.Metier;
using PcmCore.Donnees;

namespace Pcm.Gui
{
    public partial class UserEditorWindow : Form
    {
        private User user;
        private UserManager manager;

        public UserEditorWindow ()
        {
            InitializeComponent ();
        }

        public UserEditorWindow (User user)
            : this ()
        {
            this.user = user;
            this.manager = new UserManager (user);
        }

        private void WEditUtilisateur_Load (object sender, EventArgs e)
        {
            txt_nomActuel.Text = user.NomUtilisateur;
            txt_passActuel.Text = user.MotDePasse;
        }

        private void btReset_Click (object sender, EventArgs e)
        {
            txt_nomNew.Text = "";
            txt_passNew.Text = "";
            txt_passNew2.Text = "";
        }

        private void btAnnuler_Click (object sender, EventArgs e)
        {
            this.Close ();
        }

        private void btValider_Click (object sender, EventArgs e)
        {
            if (txt_nomNew.Text.Length < 4 || txt_passNew.Text.Length < 6 || txt_passNew.Text != txt_passNew2.Text)
            {
                MessageBox.Show ("Le nom d'utilisateur doit faire au moins 4 caractères, le mot de passe doit faire au moins 6 caractères",
                    "Erreur de saisie", MessageBoxButtons.OK, MessageBoxIcon.Error);
                btReset_Click (this, new EventArgs ());
            }
            else
            {
                user.NomUtilisateur = txt_nomNew.Text;
                user.MotDePasse = txt_passNew.Text;
                if (manager.ModifierDonnees ())
                    MessageBox.Show ("Changements effectués", "Modification utilisateur", MessageBoxButtons.OK, MessageBoxIcon.Information);
                else
                    MessageBox.Show ("Erreur", "Modification utilisateur", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                this.Close ();
            }
        }
    }
}
