/*
Navicat SQLite Data Transfer

Source Server         : Pcm Db
Source Server Version : 30616
Source Host           : localhost:0

Target Server Type    : SQLite
Target Server Version : 30616
File Encoding         : 65001

Date: 2010-06-28 15:42:37
*/


-- ----------------------------
-- Table structure for "contact"
-- ----------------------------
DROP TABLE "contact";
CREATE TABLE "contact" (
"idC"  INTEGER NOT NULL,
"nomC"  VARCHAR,
"prenomC"  VARCHAR,
"dateAC"  VARCHAR,
"adresseC"  VARCHAR,
"villeC"  VARCHAR,
"numFixC"  VARCHAR,
"numPortC"  VARCHAR,
"mailC"  VARCHAR,
"idUtil"  INTEGER NOT NULL,
"codePC"  VARCHAR,
PRIMARY KEY ("idC" ASC),
CONSTRAINT "fk_util_id" FOREIGN KEY ("idUtil") REFERENCES "utilisateur" ("idU")
);

-- ----------------------------
-- Records of contact
-- ----------------------------

-- ----------------------------
-- Table structure for "utilisateur"
-- ----------------------------
DROP TABLE "utilisateur";
CREATE TABLE utilisateur(idU INTEGER NOT NULL PRIMARY KEY, 
	nomU, passwdU);

-- ----------------------------
-- Records of utilisateur
-- ----------------------------

-- ----------------------------
-- Triggers structure for table "contact"
-- ----------------------------
DELIMITER ;;
CREATE TRIGGER "fki_contact_utilisateur_id" BEFORE INSERT ON "contact" FOR EACH ROW
BEGIN
	SELECT RAISE(ROLLBACK, 'Insertion : La clé étrangère nexiste pas')
	WHERE NEW.idUtil IS NOT NULL
		AND (SELECT idU FROM utilisateur WHERE idU = NEW.idUtil) IS NULL;
END
;;
DELIMITER ;
DELIMITER ;;
CREATE TRIGGER "fku_contact_utilisateur_id" BEFORE UPDATE ON "contact" FOR EACH ROW
BEGIN
	SELECT RAISE(ROLLBACK, 'Mise à jour : La clé étrangère nexiste pas')
	WHERE NEW.idUtil IS NOT NULL
		AND (SELECT idU FROM utilisateur WHERE idU = NEW.idUtil) IS NULL;
END
;;
DELIMITER ;

-- ----------------------------
-- Triggers structure for table "utilisateur"
-- ----------------------------
DELIMITER ;;
CREATE TRIGGER "fkd_utilisateur_contact_id" BEFORE DELETE ON "utilisateur" FOR EACH ROW
BEGIN
  DELETE FROM contact WHERE contact.idUtil=OLD.idU;
END
;;
DELIMITER ;
