﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SQLite;
using System.IO;

namespace PcmCore.Donnees
{
    public abstract class AbstractBddManager
    {  
        protected string NomBase { get; set; }
        protected string NomTable { get; set; }

        protected SQLiteConnection connexion;

        /// <summary>
        /// Créée une connexion avec la base de données
        /// /!\ Ne pas oublier de ferme la connexion avec connexion.Close() /!\
        /// </summary>
        protected void SetupConnexion ()
        {
            SQLiteConnectionStringBuilder connexionString = new SQLiteConnectionStringBuilder ();
            connexionString.DataSource = "pcm-data.db3";
            connexionString.FailIfMissing = true;
            connexion = new SQLiteConnection (connexionString.ToString ());      
        }

        /// <summary>
        /// Création automatique de la base de données en cas de crash ou de fichiers manquants/corrompus
        /// </summary>
        public void CreerStructure ()
        {
            // TODO
            // Charger le fichier Base/main.sql
            // et l'exécuter
            throw new NotImplementedException ();
        }

        public abstract bool AjouterDonnees ();
        public abstract bool SupprimerDonnees ();
        public abstract bool ModifierDonnees ();
        public abstract int VerifierDonnees ();
    }
}
