﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

using PcmCore.Metier;
using PcmCore.Donnees;
using PcmCore.Event;

namespace PcmWpf.Gui
{
    /// <summary>
    /// Interaction logic for UserConnection.xaml
    /// </summary>
    public partial class UserConnectionWindow : Window
    {
        public event EventHandler<UserConnectedEventArgs> utilisateurConnecte;

        public UserConnectionWindow ()
        {
            InitializeComponent ();
        }
        private void btAnnuler_Click (object sender, EventArgs e)
        {
            this.Close ();
        }

        private void btConnecter_Click (object sender, EventArgs e)
        {
            if (txtUser.Text.Length >= 4 && txtPasswd.Password.Length >= 6)
            {
                User utilisateurSaisie = new User (txtUser.Text, txtPasswd.Password);
                UserManager verficationUSaisie = new UserManager (utilisateurSaisie);
                utilisateurSaisie.IdUtilisateur = verficationUSaisie.VerifierDonnees ();

                if (utilisateurSaisie.IdUtilisateur > 0)
                {
                    // Envoi de l'utilisateur à la vue pour mise à jour
                    OnUtilisateurConnecte (new UserConnectedEventArgs (utilisateurSaisie));
                    MessageBox.Show ("Connexion OK");
                    this.Close ();
                }
                else
                {
                    MessageBoxResult choixUtilisateur = MessageBox.Show ("L'utilisateur n'existe pas ou les identifiants sont incorrects", "Erreur d'identification", MessageBoxButton.OKCancel, MessageBoxImage.Exclamation);
                    if (choixUtilisateur == MessageBoxResult.Cancel)
                        this.Close ();
                }

                this.Close ();
            }
            else
            {
                MessageBox.Show ("Le nom d'utilisateur doit comporter au moins 4 caractères et le mot de passe 6 caractères", "Attention", MessageBoxButton.OK, MessageBoxImage.Exclamation);
            }
        }

        // Emission de l'utilisateur
        protected virtual void OnUtilisateurConnecte (UserConnectedEventArgs utilisateur)
        {
            utilisateurConnecte (this, utilisateur);
        }
    }
}
