﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

using PcmCore.Metier;
using PcmCore.Donnees;

namespace PcmWpf.Gui
{
    /// <summary>
    /// Interaction logic for UserEditor.xaml
    /// </summary>
    public partial class UserEditorWindow : Window
    {
        private User user;
        private UserManager manager;

        public UserEditorWindow ()
        {
            InitializeComponent ();
        }

        public UserEditorWindow (User user)
            : this ()
        {
            this.user = user;
            this.manager = new UserManager (user);
        }

        private void btAnnuler_Click (object sender, RoutedEventArgs e)
        {
            this.Close ();
        }

        private void btValider_Click (object sender, RoutedEventArgs e)
        {
            if (txtUser.Text.Length < 4 || txtPasswd.Password.Length < 6 || txtPasswd.Password != txtPasswd2.Password)
            {
                MessageBox.Show ("Le nom d'utilisateur doit faire au moins 4 caractères, le mot de passe doit faire au moins 6 caractères",
                    "Erreur de saisie", MessageBoxButton.OK, MessageBoxImage.Error);
            }
            else
            {
                user.NomUtilisateur = txtUser.Text;
                user.MotDePasse = txtPasswd.Password;
                if (manager.ModifierDonnees ())
                    MessageBox.Show ("Changements effectués", "Modification utilisateur", MessageBoxButton.OK, MessageBoxImage.Information);
                else
                    MessageBox.Show ("Erreur", "Modification utilisateur", MessageBoxButton.OK, MessageBoxImage.Warning);
                this.Close ();
            }
        }

        private void Window_Loaded (object sender, RoutedEventArgs e)
        {
            txtOldUser.Text = user.NomUtilisateur;
            txtOldPasswd.Text = user.MotDePasse;
        }
    }
}
